SEARCH_URL_FORMAT = "http://image.baidu.com/search/acjson?tn=resultjson&word=${keyword}&keyword=${keyword}&rn=${count}&pn=${index}&ie=utf-8&oe=utf-8&ipn=rj";

//global imports
log = Packages.com.babycloud.headportrait.util.MyLog.log;

Matcher    = java.util.regex.Matcher;
Pattern    = java.util.regex.Pattern;
//saveFile   = com.babycloud.headportrait.util.FileUtil.saveFile;

DEBUG = false;

RETURN_STRING = "[]";
function setResult( rs ) {
    RETURN_STRING = rs;
}

//log("jsscript","hello from jsscript file! .arg=" + arg );
//saveFile(arg, "dump.js.got.input.txt");

if(arg==null || arg.length==0) {
    log("jsscript", "no input text to parse, so return immediately.");
}else {
    var imgs = parseImagesFromText( arg );
    var strImgsJson = JSON.stringify(imgs);
    if(DEBUG) {
        log("jsscript", "===>strImgsJson : " + strImgsJson);
    }
    setResult( strImgsJson );
}




//====================================================================

var gCachedRegexp = {k:null};
function getCompiledPattern( regexp ) {
    return Pattern.compile(regexp, Pattern.DOTALL|Pattern.MULTILINE);
}

function parseImagesFromText( text ) {
    var sBlockContainsImgData = "";
    // try #0 json whole text
    return parseImagesFromImgTextBlock(text );

    // try #1 regexp to extract img data text block
    var row = findSingleMatch(text, "'imgData'([\\s\\S]+?)app.setData");
    if( row!=null ) {
        sBlockContainsImgData = row[1];
    }

    if(sBlockContainsImgData.length > 100) {
        return parseImagesFromImgTextBlock(sBlockContainsImgData );
    }

    // try #2 regexp to extract img data text block
    row = findSingleMatch(text, "imgs:([\\s\\S]+?)headPic");
    if( row!=null ) {
        sBlockContainsImgData = row[1];
    }
    return parseImagesFromImgTextBlock(sBlockContainsImgData );
}

function parseImagesFromImgTextBlock( imgBlockText ) {
    var imgs = [];
    var imgTextList = findMultipleMatch(imgBlockText, "\\{(?:[\\s\\S]*?)\"thumbURL\"([^}]*)\\}");
    for( var i=0; i<imgTextList.length; i++ ) {
        var imgInfoString = imgTextList[i][0];
        //thumb:
        var imgThumbUrl = ""; //   "\"thumbURL\":\"([^\"]+)\""
        var tmpTokens = findSingleMatch(imgInfoString, "\"thumbURL\":\"([^\"]+)\"");
        if(tmpTokens == null) {
            continue;
        }
        imgThumbUrl = tmpTokens[1];

        //img:
        var imgUrl = "";
        tmpTokens = findSingleMatch(imgInfoString, "\"objURL\":\"([^\"]+)\"");
        if(tmpTokens == null) {
            continue;
        }
        imgUrl = tmpTokens[1];

        if(imgUrl.length==0) {
            imgUrl = imgThumbUrl;
        }

        //fromURL:
        var fromURL = "";
        var tmpTokens = findSingleMatch(imgInfoString, "\"fromURL\":\"([^\"]+)\"");
        if(tmpTokens != null) {
            fromURL = tmpTokens[1];
        }

        //fromURLHost:
        var fromURLHost = "";
        var tmpTokens = findSingleMatch(imgInfoString, "\"fromURLHost\":\"([^\"]+)\"");
        if(tmpTokens != null) {
            fromURLHost = tmpTokens[1];
        }

        var img = new Object();
        img.thumbURL = imgThumbUrl;
        img.imageURL = imgUrl;
        img.fromURL = fromURL;
        img.fromURLHost = fromURLHost;
        imgs.push(img);
    }
    return imgs;
}
function findMultipleMatch( text, regexp ) {
    var rows = new Array();
    var oPattern = getCompiledPattern(regexp);
    var mat = oPattern.matcher(text);
    while (mat.find()) {
        var row = new Array();
        for(var i=0; i<=mat.groupCount(); i++) {
            var token = ""+mat.group(i);
            row.push( token );
        }
        rows.push( row );
    }
    return rows;
}
function findSingleMatch( text, regexp ) {
    var oPattern = getCompiledPattern(regexp);
    var mat = oPattern.matcher(text);
    if (mat.find()) {
        var row = new Array();
        for(var i=0; i<=mat.groupCount(); i++) {
            var token = ""+mat.group(i);
            row.push( token );
        }
        return row;
    }
    return null;
}






